#include <Servo.h>
#include <MsTimer2.h>
typedef signed char             S8 ;  //!< 8-bit signed integer.
typedef unsigned char           U8 ;  //!< 8-bit unsigned integer.
typedef signed short int        S16;  //!< 16-bit signed integer.
typedef unsigned short int      U16;  //!< 16-bit unsigned integer.
typedef signed long int         S32;  //!< 32-bit signed integer.
typedef unsigned long int       U32;  //!< 32-bit unsigned integer.
typedef signed long long int    S64;  //!< 64-bit signed integer.
typedef unsigned long long int  U64;  //!< 64-bit unsigned integer.
typedef float                   F32;  //!< 32-bit floating-point number.
typedef double                  F64;  //!< 64-bit floating-point number.

// Pin 13 has an LED connected on most Arduino boards.
// give it a name:
U8 led = 13;
U8 servopin = 5;
U8 currentAdcChannel = 3; //A0
U8 TAU2 = 64;
U8 counter = TAU2;
U8 isrv;
boolean audMean_initialized = 0, meanSq_initialized = 0;
boolean FLAG_PWM = 0;
U8 TAU1 = 64;
S32 meanSq, sqmax=0, sqmin=1000000;
S32 adcval, audMean, diff, sqval;

Servo myservo;
// the setup routine runs once when you press reset:
void setup() {                
  // initialize the digital pin as an output.
  pinMode(led, OUTPUT);
  Serial.begin(115200);
  Serial.println("Start");
  myservo.attach(servopin,1000,2000);
  myservo.write(0);
  ADMUX = (B01000000 | currentAdcChannel);
  MsTimer2::set(1,t2_ovf);
  MsTimer2::start();
}
// the loop routine runs over and over again forever:
U8 i=0;
void loop() {
  if (FLAG_PWM)
  {
    isrv=(U8)map(meanSq,sqmin,sqmax,0,180);
    myservo.write(isrv);
    /*Serial.print("audMean, meanSq, sqmax, isrv, adcval:");
    Serial.print(audMean);
    Serial.print(", ");
    Serial.print(meanSq);
    Serial.print(", ");
    Serial.print(sqmax);
    Serial.print(", ");
    Serial.print(isrv);
    Serial.print(", ");
    Serial.println(adcval);*/
    digitalWrite(led, !digitalRead(led));
    if (sqmin > meanSq) sqmin = meanSq;
    if (sqmax < meanSq) sqmax = meanSq;
    FLAG_PWM = 0;
  }
}

void t2_ovf()
{
 // Serial.println("t2");
  adc_start();
  digitalWrite(3, !digitalRead(3));
}
void adc_start()
{
  ADCSRA = B11001111;
}
ISR(ADC_vect)
{
  U8 adc_l = ADCL;
  U8 adc_h = ADCH;
  adcval = adc_h*256+adc_l;
  //Serial.println(adcval);
  dsp_process();
}
void dsp_process() 
{
 if (audMean_initialized) audMean = (adcval + audMean*TAU1 - audMean)/TAU1;//((adcval - audMean)>>NTAU1) + audMean;
 else { audMean = adcval; audMean_initialized = 1; }

 if (counter==0)
 {
   //Serial.println("TAU2 ADC conversions");
   counter = TAU2;
   diff = adcval - audMean;
   sqval = diff*diff;
   if (meanSq_initialized) meanSq = (sqval + meanSq*TAU1 - meanSq)/TAU1;
   else { meanSq = sqval; meanSq_initialized = 1;}
   FLAG_PWM = 1;
 } else counter--;
}
